import Flutter
import UIKit

public class SwiftVdocipherFlutterPlugin: NSObject, FlutterPlugin {
    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "com.vdocipher.flutter", binaryMessenger: registrar.messenger())
        let instance = SwiftVdocipherFlutterPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
        
        let factory = VdoNativeViewFactory(messenger: registrar.messenger())
        registrar.register(factory, withId: "com.vdocipher.flutter/vdoplayerview")
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
//        print("CALL_METHOD: " + call.method)
        
        switch(call.method) {
        case "getNativeIOSLibraryVersion":
            result("iOS Test" + UIDevice.current.systemVersion);
            break;
            
        default:
            result("unsupported call method: " + call.method);
        }
    }
}
