import 'package:vdocipher_flutter/vdocipher_flutter.dart';

import 'embed_info_options.dart';

/// Initial parameters specifying the video to load and playback preferences.
class EmbedInfo {
  final bool offline;
  final String? otp;
  final String? playbackInfo;
  final String? mediaId;
  final EmbedInfoOptions? embedInfoOptions;
  final Duration? skipDuration;
  final List<double>? playbackSpeedOptions;

  const EmbedInfo.streaming(
      {required String this.otp,
      required String this.playbackInfo,
      this.embedInfoOptions,
      this.skipDuration,
      this.playbackSpeedOptions = PlaybackSpeedOptions})
      : offline = false,
        mediaId = null;

  const EmbedInfo.offline(
      {required String this.mediaId,
      this.embedInfoOptions,
      this.skipDuration,
      this.playbackSpeedOptions})
      : offline = true,
        otp = null,
        playbackInfo = null;

  Map<String, Object?> toMap() {
    return {
      'offline': offline,
      'otp': otp,
      'playbackInfo': playbackInfo,
      'mediaId': mediaId,
      'embedInfoOptions':
          embedInfoOptions == null ? null : embedInfoOptions!.toMap()
    };
  }
}
